//////////////////////////////////////////////////////////////
// Maillage du rservoir
//////////////////////////////////////////////////////////////

// Variables
// Rayon interne du rservoir
Rint = 1;
// Epaisseur de la paroi
ep   = 0.02;
// Rayon externe du reservoir
Rext = Rint+ep;
// Hauteur du reservoir
h    = 4;
// Nombre d'elements sur l'horizontale
nbelh= 5;
// Nombre d'elements sur la verticale
nbelv= 20;

// Points
Point(1) = {Rint,0,0,1};
Point(2) = {Rext,0,0,1};
Point(3) = {Rext,0.75*h,0,1};
Point(4) = {Rext,h,0,1};
Point(5) = {Rint,h,0,1};
Point(6) = {Rint,0.75*h,0,1};

// Lignes
Line(1) = {1,2};
Line(2) = {2,3};
Line(3) = {3,4};
Line(4) = {4,5};
Line(5) = {5,6};
Line(6) = {6,1};
Line(7) = {6,3};


// Surface rgle pour maillage rgl
Line Loop(1) = {-2,-1,-6,7};
Ruled Surface(1) = {1};
Line Loop(2) = {3, 4, 5, 7};
Ruled Surface(2) = {2};

// Description des groupes de mailles/noeuds (points)
Physical Point(1) = {1};
Physical Point(2) = {2};
Physical Point(3) = {3};
Physical Point(4) = {4};
Physical Point(5) = {5};
Physical Point(6) = {6};

// Description des groupes de mailles/noeuds (lignes)
Physical Line(11) = {1};
Physical Line(12) = {4};
Physical Line(13) = {5};
Physical Line(14) = {6};

// Description des groupes de mailles/noeuds (surface)
Physical Surface(21) = {1,2};

// Finesse du maillage (rgl)
Transfinite Line{1}  = nbelh+1;
Transfinite Line{4}  = nbelh+1;
Transfinite Line{7}  = nbelh+1;
Transfinite Line{5,3}= 0.25*nbelv+1;
Transfinite Line{2,6}= 0.75*nbelv+1;

Transfinite Surface{1} = {3,6,1,2};
Transfinite Surface{2} = {3, 4, 5, 6};

// Passage triangles->quadrangles
Recombine Surface {1,2};
